SystemOrganization addCategory: #VisuAule!
SystemOrganization addCategory: #'VisuAule-Objects'!
SystemOrganization addCategory: #'VisuAule-Objects-Tests'!
SystemOrganization addCategory: #'VisuAule-Example'!

!Number methodsFor: '*visuaule-objects' stamp: 'CamiloGomez 6/27/2012 15:38'!
shouldBeAddedAsElement
	^ false! !

!String methodsFor: '*visuaule-objects' stamp: 'CamiloGomez 6/27/2012 15:39'!
shouldBeAddedAsElement
	^ false! !

TestCase subclass: #VisuAuleTest
	instanceVariableNames: 'book ralph eric joe'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VisuAule-Objects-Tests'!

!VisuAuleTest methodsFor: 'running' stamp: 'CamiloGomez 7/5/2012 12:12'!
setUp
	
	book := VABook new name: 'design patterns'.
	ralph := VAPerson new name: 'Ralph Johnson'.
	eric := VAPerson new name: 'Eric Gamma'.
	book addAuthor: ralph; addAuthor: eric.
	
	joe := VAPerson new.
	joe readBook: book.! !

!VisuAuleTest methodsFor: 'testing scenarios' stamp: 'CamiloGomez 7/5/2012 12:12'!
testPerson

	"The scenario we are here simulating is (person visualize)"
	
	| view |
	
	view := ROView new.
	
	ralph visualizeOn: view.
	eric visualizeOn: view.
	
	"view open"
	
	self assert: view elements size = 2! !

!VisuAuleTest methodsFor: 'testing scenarios' stamp: 'CamiloGomez 7/5/2012 12:12'!
testVisualizingBooksAndPersons

	"The scenario we are here simulating is (book new visualize)"
	
	| view |
		
	view := ROView new.
	
	self assert: view elements isEmpty.
	book visualizeOn: view.
	"view open"
	self assert: view elements size = 5.
	self assert: (view elementFromModel: book) notNil.
	self assert: (view elementFromModel: ralph) notNil.
	self assert: (view elementFromModel: eric) notNil.
	self assert: (view elementFromModel: joe) isNil.! !

!VisuAuleTest methodsFor: 'testing scenarios' stamp: 'CamiloGomez 7/5/2012 12:12'!
testVisualizingPoint

	"The scenario we are here simulating is (2@4) visualize"
	
	| view |
	view := ROView new.
	
	self assert: view elements isEmpty.
	(2 @ 4) visualizeOn: view.
	(10 @ 10) visualizeOn: view.
	"view open."
	self assert: view elements size = 2.! !

!SystemOrganizer methodsFor: '*visuaule-objects' stamp: 'CamiloGomez 7/5/2012 13:09'!
shouldBeAddedAsElement
	^false! !

!Boolean methodsFor: '*visuaule-objects' stamp: 'CamiloGomez 7/5/2012 13:10'!
shouldBeAddedAsElement 
	^false! !

!UndefinedObject methodsFor: '*visuaule-objects' stamp: 'CamiloGomez 6/27/2012 15:50'!
shouldBeAddedAsElement
	^ false! !

!Browser methodsFor: '*visuaule-objects' stamp: 'CamiloGomez 7/6/2012 12:23'!
interactionFor: element on: view

	super interactionFor: element on: view.
	
	element on: ROMouseLeftClick do: [ :event | Browser open].! !

!Object methodsFor: '*visuaule-objects' stamp: 'CamiloGomez 6/29/2012 15:56'!
addElement: el of: elementForSelf on: view

	 self interactionFor: el on: view.
	 view add: el.
	 view add: (ROEdge lineFrom: elementForSelf to: el)! !

!Object methodsFor: '*visuaule-objects' stamp: 'CamiloGomez 6/29/2012 15:43'!
addReferencedObjectsOf: elementForSelf on: view

	 self class instVarNames do: [ :varName |
		| el object |
		object := self instVarNamed: varName.
		object shouldBeAddedAsElement
			ifTrue: 
				[object isCollection
					ifTrue: [object do: [ :element | 
								el := self roassalElementFor: element.
				 				self addElement: el of: elementForSelf on: view.]]
					ifFalse: [el := self roassalElementFor: object.
				 			self addElement: el of: elementForSelf on: view.]]]! !

!Object methodsFor: '*visuaule-objects' stamp: 'CamiloGomez 7/5/2012 13:15'!
elementsNotAdded

	| otherElements elementObject parentPosition |
	otherElements := OrderedCollection new.
	
	self class instVarNames do: [ :varName |
		| el object |
		object := self instVarNamed: varName.
		elementObject := self roassalElementFor: object.
		parentPosition := elementObject position.		
		object shouldBeAddedAsElementOnEnter
		ifTrue: [ object notNil ifTrue: [otherElements add: (elementObject translateTo: (parentPosition + (10@0)))]]].
	
	^ otherElements! !

!Object methodsFor: '*visuaule-objects' stamp: 'CamiloGomez 6/29/2012 15:29'!
interactionFor: element
	element @ (ROMenuActivable new item: 'inspect element' action: #inspect;
									item: 'browse element class' action: #browse).

	"element on: ROMouseLeftClick do: [ :event | 
			element + (ROLabel text: [((self class instVarNames) at: 1)])]"
					
			! !

!Object methodsFor: '*visuaule-objects' stamp: 'CamiloGomez 6/29/2012 17:26'!
interactionFor: element on: view

	| otherElements elementObject |
	element @ (ROMenuActivable new item: 'inspect element' action: #inspect;
									item: 'browse element class' action: #browse).

	otherElements := self elementsNotAdded.
	
	element on: ROMouseEnter do: [ :event | 
			view addAll: otherElements].
		
	element on: ROMouseLeave do: [ :event | 
			otherElements do: [ :each | view remove: each]]! !

!Object methodsFor: '*visuaule-objects' stamp: 'CamiloGomez 6/29/2012 15:54'!
roassalElementFor: object
	| element |
	
	element := ROElement on: object.
	element + ROBorder + ROLabel.
	element translateTo: 5@5 .
	element @ ROLightlyHighlightable @ RODraggable.
	"element shapesDo: [ :d | d color: Color red]."
	
	^ element! !

!Object methodsFor: '*visuaule-objects' stamp: 'CamiloGomez 6/29/2012 15:43'!
setLayoutOn: view

	ROTreeLayout new 
				translator: (ROSmoothLayoutTranslator new);
				applyOn: view elements.! !

!Object methodsFor: '*visuaule-objects' stamp: 'CamiloGomez 6/27/2012 15:38'!
shouldBeAddedAsElement
	^ true! !

!Object methodsFor: '*visuaule-objects' stamp: 'CamiloGomez 7/5/2012 12:47'!
visualize

	| view obj |
	
	view := ROView new.
		
	self visualizeOn: view.
	
	view open.
! !

!Object methodsFor: '*visuaule-objects' stamp: 'CamiloGomez 6/29/2012 17:32'!
visualizeOn: view  
	"We add the object"
	| elementForSelf |
	elementForSelf := self roassalElementFor: self.
	self interactionFor: elementForSelf on: view.
	view add: elementForSelf.
	
	"We add the referenced objects"
	self addReferencedObjectsOf: elementForSelf on: view.
	
	"We set a Layout, in this case, treeLayout"
	self setLayoutOn: view.! !

Object subclass: #VABook
	instanceVariableNames: 'authors title name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VisuAule-Objects'!

!VABook methodsFor: 'actions' stamp: 'CamiloGomez 6/27/2012 15:18'!
addAuthor: aPerson
	authors add: aPerson! !

!VABook methodsFor: 'initialize-release' stamp: 'CamiloGomez 6/27/2012 15:17'!
initialize
	super initialize.
	authors := OrderedCollection new.! !

!VABook methodsFor: 'accessing' stamp: 'CamiloGomez 6/27/2012 15:26'!
name: aString
	name := aString! !

Object subclass: #VAExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VisuAule-Example'!

!VAExample commentStamp: '<historical>' prior: 0!
List of examples!

!VAExample methodsFor: 'open tools' stamp: 'CamiloGomez 7/6/2012 12:20'!
browser
	"self new browser"

	Browser new visualize.! !

!VAExample methodsFor: 'as yet unclassified' stamp: 'CamiloGomez 7/6/2012 12:20'!
simpleLayout

	"self new simpleLayout"

	"Not implemented yet"! !

Object subclass: #VAPerson
	instanceVariableNames: 'name readBooks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VisuAule-Objects'!

!VAPerson methodsFor: 'initialize-release' stamp: 'CamiloGomez 6/27/2012 15:17'!
initialize
	super initialize.
	readBooks := OrderedCollection new! !

!VAPerson methodsFor: 'actions' stamp: 'CamiloGomez 6/27/2012 15:25'!
name: aString
	name := aString! !

!VAPerson methodsFor: 'actions' stamp: 'CamiloGomez 6/27/2012 15:17'!
readBook: aBook
	readBooks add: aBook! !
